; Copyright (C) 1998 by Holger Veit (Holger.Veit@gmd.de)
; Use at your own risk! No Warranty! The author is not responsible for
; any damage or loss of data caused by proper or improper use of this
; device driver.
;
        .386p

        INCL_DOSERRORS equ 1
        include bseerr.inc
        include devhlp.inc
        include devcmd.inc
        include devsym.inc

        include nop_segdef.inc
	include nop_macro.inc

DATA16 segment
; this is a semaphore pool of 10 ram semas
semtbl		dd 20 dup(0)

msgs	db 0dh,0ah,"NOP PDD Driver V 0.0",0
msg1	db "Copyright (C)1998 by Holger.Veit@gmd.de",0dh,0ah,0

msgtbl	dw	offset msgs
	dw	offset msg1

savemsg	dw	1178
	dw	1
	dw	?
	dw	?

sesddname	db	'SESDD32$'
sesdddata	dw	6 dup(0)
seshlp		dd	15 dup(?)
DATA16 	ends

DATA32	segment
DevHlp16	dd	?
DATA32	ends

CODE16 segment
        assume cs:CODE16, ds:DATA16, es:NOTHING
	public 	nop_devhlp_init16
	public	g_dhcallDS
	public	g_dhcallES
	public	thunk16$idcses

	extrn	Dos32FlatDS : abs
	extrn	SAS_SEL : abs

; this saves the devhlp entry from the request packet
; called with es:bx = reqpkt16 for function code 01bh
nop_devhlp_init16 proc far
int 3
	push	es
	push	ebx
	push	eax
	ASSUME	es:NOTHING
	mov	eax,dword ptr es:[bx+14]	; devhlp entry point
	mov	bx, Dos32FlatDS
	mov	es, bx
	ASSUME	es:FLAT
	mov	dword ptr es:[DevHlp16], eax
	pop	eax
	pop	ebx
	pop	es
	ASSUME	es:NOTHING
	retf
nop_devhlp_init16 endp

	ASSUME	cs:CODE16, DS:FLAT, ES:FLAT

g_dhcallDS proc far
	ASSUME	ds:FLAT
	call	ds:[DevHlp16]
	retf32
g_dhcallDS endp

g_dhcallES proc far
	assume	es:FLAT
	call	es:[DevHlp16]
	retf32
g_dhcallES endp

thunk16$idcses:
	ASSUME	ds:DATA16
	call	dword ptr ds:[sesdddata+6]
	jmp	far ptr FLAT:thunk32ret$idcses
CODE16 ends

CODE32 segment
	ASSUME cs:FLAT, DS:FLAT, ES:FLAT

	public	DH_Init32
	public	DH_RamSemRequest
	public	DH_RamSemClear
	public	DH_VMAlloc
	public	DH_VMFree
	public	DH_VMLock
	public	DH_VMUnlock
	public	DH_VerifyAccess
	public	DH_VirtToLin
	public	DH_StackToLin
	public	DH_GetGInfoSeg
	public	DH_GetLInfoSeg
	public	DH_Security
	public	DH_SaveMessage
	public	DH_AttachSes
	public	thunk32ret$idcses

; part 2 of initialization
; void* DH_Init32(void)
DH_Init32 proc near
	push	ds
	push	es
	push	ebx
	push	ecx
	push	edx

	; stuff inherited from MWDD32 by Matthieu Willm
	mov	al, 9		; undocumented
	xor	cx,cx
	mov	dl, DevHlp_GetDOSVar
	call16	g_dhcallES
	jc	ex0

	; es:bx is DOSTable
	mov	es,ax
	ASSUME	es:NOTHING
	movzx	ebx,bx
	movzx	ecx, byte ptr es:[ebx]		; number of entries in DosTable
	mov	eax, es:[ebx + 4*ecx + 46]	; offset of kernel TKSSBASE
	jmp	short ex00

ex0:	xor	eax,eax
ex00:	pop	edx
	pop	ecx
	pop	ebx
	pop	es
	pop	ds
	ASSUME	ds:FLAT
	ret
DH_Init32 endp

; APIRET _System DH_RamSemRequest(int semindex,		/* ebp+8 */
;				  long timeout);	/* ebp+12 */
DH_RamSemRequest proc near
	push	ebp
	mov	ebp,esp
	push	ebx
	push	ecx
	push	edx
	push	edi

	mov	cx, [ebp+8]	; get index
	mov	ax, DATA16
	mov	bx, offset semtbl
	shl	cx, 3
	add	bx,cx
	mov	cx, [ebp+12]
	mov	di, [ebp+14]
	mov	dl, DevHlp_SemRequest
	call16	g_dhcallES
	jc	short ex1
	xor	eax,eax
ex1:	pop	edi
	pop	edx
	pop	ecx
	pop	ebx
	pop	ebp
	ret
DH_RamSemRequest	endp

; 
; APIRET _System DH_RamSemClear(int semindex);		/* ebp+8 */
DH_RamSemClear	proc near
	push	ebp
	mov	ebp,esp
	push	ebx
	push	ecx
	push	edx
	push	edi

	mov	ecx, [ebp+8]	; get index
	mov	ax, DATA16
	mov	bx, offset semtbl
	shl	ecx, 3
	add	bx,cx
	mov	dl, DevHlp_SemClear
	call16	g_dhcallES
	jc	short ex2
	xor	eax,eax
ex2:	pop	edi
	pop	edx
	pop	ecx
	pop	ebx
	pop	ebp
	ret
DH_RamSemClear	endp

; APIRET _System DH_VMAlloc(ULONG len,		/* ebp + 8  */
;			    ULONG paddr,	/* ebp + 12 */
;			    ULONG flgs,		/* ebp + 16 */
;			    void** laddr);	/* ebp + 20 */
DH_VMAlloc proc near
	push	ebp
	mov	ebp,esp
	push	ebx
	push	ecx
	push	edx
	push	edi

	mov	ecx, [ebp+8]
	mov	edi, [ebp+12]
	mov	eax, [ebp+16]
	mov	dl, DevHlp_VMAlloc
	call16	g_dhcallES
	jc	short ex3
	mov	ebx, [ebp+20]
        mov	es:[ebx], eax
	xor	eax,eax
ex3:	pop	edi
	pop	edx
	pop	ecx
	pop	ebx
	pop	ebp
	ret
DH_VMAlloc endp

; APIRET _System DH_VMFree(void* laddr);	/* ebp + 8  */
DH_VMFree proc near
	push	ebp
	mov	ebp,esp
	push	edx

	mov	eax, [ebp+8]
	mov	dl,DevHlp_VMFree
	call16	g_dhcallES
	jc	short ex4
	xor	eax,eax
ex4:	pop	edx
	pop	ebp
	ret
DH_VMFree endp

; APIRET _System DH_VMLock(ULONG flgs,		/* ebp + 8  */
;			    ULONG laddr,	/* ebp + 12 */
;			    ULONG len,		/* ebp + 16 */
;			    void* pages,	/* ebp + 20 */
;			    void* lockh,	/* ebp + 24 */
;			    ULONG* lcnt);	/* ebp + 28 */
DH_VMLock proc near
	push	ebp
	mov	ebp,esp
	push	ebx
	push	ecx
	push	edx
	push	edi
	push	esi

	mov	eax, [ebp+8]
	mov	ebx, [ebp+12]
	mov	ecx, [ebp+16]
	mov	edi, [ebp+20]
	mov	esi, [ebp+24]
	mov	dl, DevHlp_VMLock
	call16	g_dhcallES
	jc	short ex5
	mov	ebx, [ebp+28]
        mov	es:[ebx], eax
	xor	eax,eax
ex5:	pop	esi
	pop	edi
	pop	edx
	pop	ecx
	pop	ebx
	pop	ebp
	ret
DH_VMLock endp

; APIRET _System DH_VMunlock(void* lockh);	/* ebp + 8  */
DH_VMUnlock proc near
	push	ebp
	mov	ebp,esp
	push	edx
	push	esi

	mov	esi, [ebp+8]
	mov	dl, DevHlp_VMAlloc
	call16	g_dhcallES
	jc	short ex6
	xor	eax,eax
ex6:	pop	esi
	pop	edx
	pop	ebp
	ret
DH_VMUnlock endp

; APIRET _System DH_Verifyaccess(PTR16 addr,		/* ebp + 8 */
;				 USHORT size,		/* ebp + 12 */
;				 int flgs);		/* ebp + 16  */
DH_VerifyAccess proc near
	push	ebp
	mov	ebp,esp
	push	ecx
	push	edx
	push	edi

	mov	di, [ebp+8]
	mov	ax, [ebp+10]
	mov	cx, [ebp+12]
	mov	dh, [ebp+16]
	mov	dl, DevHlp_VerifyAccess
	call16	g_dhcallES
	jc	short ex7
	xor	eax,eax
ex7:	pop	edi
	pop	edx
	pop	ecx
	pop	ebp
	ret
DH_VerifyAccess endp

; APIRET _System DH_VirtToLin(PTR16 addr,	/* ebp + 8 */
;			      void** laddr);	/* ebp + 12 */
DH_VirtToLin proc near
	push	ebp
	mov	ebp,esp
	push	edx
	push	esi

	movzx	esi, word ptr [ebp+8]
	mov	ax, [ebp+10]
	mov	dl, DevHlp_VirtToLin
	call16	g_dhcallES
	jc	short ex8
	mov	esi, [ebp+12]
	mov	es:[esi], eax
	xor	eax, eax
ex8:	pop	esi
	pop	edx
	pop	ebp
	ret
DH_VirtToLin endp

; void* _System DH_StackToLin(ULONG stackoff);
DH_StackToLin proc near
	push	ebp
	mov	ebp,esp
	push	edx
	push	esi

	mov	esi, dword ptr [ebp+8]
	mov	ax, ss
	mov	dl, DevHlp_VirtToLin
	call16	g_dhcallES
	jnc	short ex8a
	xor	eax, eax
ex8a:	pop	esi
	pop	edx
	pop	ebp
	ret
DH_StackToLin endp

; void* _System DH_GetGInfoSeg()
DH_GetGInfoSeg proc near
	push	ebp
	mov	ebp,esp
	push	es
	push	ebx
	push	edx
	push	esi

	mov	eax, SAS_SEL
	mov	es, ax			; point to SAS
	ASSUME	es:NOTHING
	xor	bx, bx
	mov	bx, word ptr es:[bx+14h]	; get offset of infoseg section
	movzx	eax, word ptr es:[bx]		; get offset of global info ptr

	xor	esi, esi			; eax:esi = giseg
	mov	dl, DevHlp_VirtToLin
	call16	g_dhcallDS
	jnc	short ex9			; no error? return eax
	xor	eax, eax			; error, return 0

ex9:	pop	esi
	pop	edx
	pop	ebx
	pop	es
	pop	ebp
	ret
DH_GetGInfoSeg endp

; void* _System DH_GetLInfoSeg()
DH_GetLInfoSeg proc near
	push	ebp
	mov	ebp,esp
	push	es
	push	ebx
	push	edx
	push	esi

	mov	eax, SAS_SEL
	mov	es, ax				; point to SAS
	ASSUME	es:NOTHING
	xor	bx, bx
	mov	bx, word ptr es:[bx+14h]	; get offset of infoseg section

	movzx	eax, word ptr es:[bx+4]		; get seg of local info ptr
	movzx	esi, word ptr es:[bx+2]		; get off of local info ptr
	mov	dl, DevHlp_VirtToLin
	call16	g_dhcallDS
	jnc	short ex9a			; no error, return EAX

	xor	eax, eax			; error, return 0
ex9a:	pop	esi
	pop	edx
	pop	ebx
	pop	es
	pop	ebp
	ret
DH_GetLInfoSeg endp

; APIRET _System DH_Security(ULONG func,	/* ebp + 8 */
;			     void* ptr);	/* ebp + 12 */
DH_Security proc near
	push	ebp
	mov	ebp,esp
	push	ecx
	push	edx

	mov	eax, [ebp+8]
	mov	ecx, [ebp+12]
	mov	dl, 044h	; DevHlp_Security
	call16	g_dhcallES
	jc	short ex10
	xor	eax, eax
ex10:	pop	edx
	pop	ecx
	pop	ebp
	ret
DH_Security endp

; APIRET _System DH_SaveMessage(int msgnum);	/* ebp + 8 */
DH_SaveMessage proc near
	push	ebp
	mov	ebp,esp
	push	ds
	mov	ax, DATA16
	mov	ds, ax
	ASSUME	ds:DATA16, ES:FLAT
	push	ebx
	push	edx
	push	esi

	mov	bx, [ebp+8]
	shl	bx, 1
	mov	ax, [bx+msgtbl]
	mov	word ptr [savemsg+4], ax
	mov	ax, ds
	mov	word ptr [savemsg+6], ax

	; ds is already pointing to DATA16
	mov	si, offset savemsg
	xor	bx, bx	
	mov	dl, DevHlp_Save_Message
	call16	g_dhcallES
	jc	short ex11
	xor	eax, eax
ex11:	pop	esi
	pop	edx
	pop	ebx
	pop	ds
	pop	ebp
	ret
DH_SaveMessage endp

; APIRET DH_AttachSes(struct SecurityHelper*)	/* ebp+8 */
DH_AttachSes	proc near
	push	ebp
	mov	ebp, esp
	ASSUME	ds:FLAT, es:FLAT
	push	ds
	push	es
	push	ebx
	push	ecx
	push	edx
	push	esi
	push	edi
	mov	bx, DATA16
	mov	ds, bx
	ASSUME	ds:DATA16
	mov	bx, offset sesddname
	mov	di, offset sesdddata
	mov	dl, DevHlp_AttachDD
	call16	g_dhcallES
	jc	ex12

	push	ds			; swap: DS=FLAT, ES=DATA16
	push	es
	pop	ds
	pop	es

	ASSUME	ds:FLAT,es:DATA16
	mov	esi, [ebp+8]		; copy the preloaded buffer
	mov	edi, offset seshlp	; this is necessary to get element 15
	mov	ecx, 15
	cld
	rep	movsd			; ds:esi -> es:edi

	push	ds			; swap: DS=DATA16, ES=FLAT
	push	es
	pop	ds
	pop	es

	ASSUME	ds:DATA16, es:FLAT
	lea	esi, [seshlp]
	push	esi
	jmp	far ptr thunk16$idcses
thunk32ret$idcses:
	pop	esi

	mov	edi, [ebp+8]
	cld
	mov	ecx, 15
	rep	movsd			; ds:esi -> es:edi

	xor	eax,eax
ex12:	pop	edi
	pop	esi
	pop	edx
	pop	ecx
	pop	ebx
	pop	es
	pop	ds
	pop	ebp
	ret
DH_AttachSes	endp

CODE32 ends

end
