/* Copyright (C) 1997,1998 by Holger Veit (Holger.Veit@gmd.de) */
/* Use at your own risk! No Warranty! The author is not responsible for
 * any damage or loss of data caused by proper or improper use of this
 * device driver.
 */
#define INCL_BASE
#define INCL_DOS
#define INCL_DOSERRORS
#define INCL_NOPMAPI
#include "nop.h"
#include "nop_devhlp.h"
#include "reqpkt32.h"
#include <string.h>

extern unsigned short codeend;
extern unsigned short dataend;
extern PTR16          DevHelp2;

extern char code32_end;
extern char data32_end;

extern void begin_code32(void);
extern int  begin_data32;

int nop_lockseg(void) 
{
	ULONG	cnt;
	char	lock[12];

	/* Locks DGROUP into physical memory */
	return DH_VMLock(VMDHL_LONG | VMDHL_WRITE | VMDHL_VERIFY,
			 &begin_data32,
			 (ULONG)(&data32_end) - (ULONG)(&begin_data32),
			 (void*)-1l, StackToFlat(lock),
			 StackToFlat(&cnt)) ||
	/* Locks CODE32 into physical memory */
	       DH_VMLock(VMDHL_LONG | VMDHL_VERIFY,
			 (void *)begin_code32,
			 (ULONG)(&code32_end) - (ULONG)begin_code32,
			 (void *)-1l, StackToFlat(lock),
			 StackToFlat(&cnt)) ? -1 : 0;
}

int nop_drvinit_base(PTR16 reqpkt) 
{
	int status = 0;
	int rc;
	struct reqpkt_init *request;

	TKSSBase = DH_Init32(); /* set the TKSSBase pointer */

	if (DH_VirtToLin(reqpkt, StackToFlat(&request)) != 0)
		return STDON|STERR|ERROR_I24_QUIET_INIT_FAIL;

	if (nop_lockseg() != 0)
		return STDON|STERR|ERROR_I24_QUIET_INIT_FAIL;

	DH_SaveMessage(0);
	DH_SaveMessage(1);

	request->u.output.codeend = codeend;
	request->u.output.dataend = dataend;
	return STDON;
}
