/* Copyright (C) 1997 by Holger Veit (Holger.Veit@gmd.de) */
/* Use at your own risk! No Warranty! The author is not responsible for
 * any damage or loss of data caused by proper or improper use of this
 * device driver.
 */
#define INCL_DOSERRORS
#define INCL_DOS
#define INCL_NOPMAPI
#include "nop.h"
#include <reqpkt32.h>
#include "nop_devhlp.h"

int (*driver_routing_table[32])() = {
    nop_invalid_command,  // 0 = Init
    nop_invalid_command,  // 1 = Media Check
    nop_invalid_command,  // 2 = Build BPB
    nop_invalid_command,  // 3 = Reserved
    nop_invalid_command,  // 4 = Read
    nop_invalid_command,  // 5 = Non-Destruct Read NoWait
    nop_invalid_command,  // 6 = Input Status
    nop_invalid_command,  // 7 = Input Flush
    nop_invalid_command,  // 8 = Write
    nop_invalid_command,  // 9 = Write w/Verify
    nop_invalid_command,  // A = Output Status
    nop_invalid_command,  // B = Output Flush
    nop_invalid_command,  // C = Reserved
    nop_drvopen,          // D = Device Open (R/M)
    nop_drvclose,         // E = Device Close (R/M)
    nop_invalid_command,  // F = Removable Media (R/M)
    nop_drvioctl,         // 10 = Generic Ioctl
    nop_invalid_command,  // 11 = Reset Media
    nop_invalid_command,  // 12 = Get Logical Drive Map
    nop_invalid_command,  // 13 = Set Logical Drive Map
    nop_invalid_command,  // 14 = DeInstall
    nop_invalid_command,  // 15 = 
    nop_invalid_command,  // 16 = Get # Partitions
    nop_invalid_command,  // 17 = Get Unit map
    nop_invalid_command,  // 18 = No caching read
    nop_invalid_command,  // 19 = No caching write
    nop_invalid_command,  // 1A = No caching write w/Verify
    nop_drvinit_base,     // 1B = Initialize BASEDEV
    nop_drvshutdown,      // 1C = Shutdown
    nop_invalid_command,  // 1D = Get DCS/VCS
    nop_invalid_command,  // 1E =
    nop_drvinit_complete  // 1F = Init Complete
};


/*
 * This is the 32 bits strategy entry point
 */
int _Far32 _Pascal _loadds nop_strategy(PTR16 reqpkt, int index) {
    int status;

    if (index < sizeof(driver_routing_table) / sizeof(*driver_routing_table))
        status = driver_routing_table[index](reqpkt);
    else
        status = STDON + STERR + ERROR_I24_INVALID_PARAMETER;
    return status;
}

int open_count;

int nop_drvopen(PTR16 reqpkt) {
    int                 status;
    int                 rc;
    struct reqpkt_open *request;

    status = 0;
    if ((rc = DH_VirtToLin(reqpkt, StackToFlat(&request))) == NO_ERROR) {
        open_count ++;
    } else {
        /*
         * could not thunk reqpkt
         */
        status |= STERR + ERROR_I24_INVALID_PARAMETER;
    }

    return (status | STDON);
}

int nop_drvclose(PTR16 reqpkt) {
    int                  status;
    int                  rc;
    struct reqpkt_close *request;

    status = 0;
    if ((rc = DH_VirtToLin(reqpkt, StackToFlat(&request))) == NO_ERROR) {
        open_count --;
    } else {
        status |= STERR + ERROR_I24_INVALID_PARAMETER;
    }

    return (status | STDON);
}

int nop_drvshutdown(PTR16 reqpkt) 
{
    return STDON;
}

int nop_drvinit_complete(PTR16 reqpkt) 
{
    return STDON;
}

int nop_invalid_command (PTR16 reqpkt) 
{
    return STDON + STERR + ERROR_I24_BAD_COMMAND;
}

int nop_drvioctl(PTR16 reqpkt) 
{
	return STDON;
}

/*
 * sample 32 bits IDC entry point
 */
int _Far32 _Pascal _loadds nop_idc(void) 
{
    return 0;
}
