/* Copyright (C) 1997 by Holger Veit (Holger.Veit@gmd.de) */
/* Use at your own risk! No Warranty! The author is not responsible for
 * any damage or loss of data caused by proper or improper use of this
 * device driver.
 */
#ifndef _NOP_TYPES_H_
#define _NOP_TYPES_H_

typedef ULONG PTR16;

typedef struct {
	USHORT o,s;
} ADDR16;

#pragma pack(1)
struct frame16 {
/*0*/	ULONG	fr16_apiedi;		/* registers passed to API worker */
/*4*/	ULONG	fr16_apiesi;		/* may be modified, check the actual */
/*8*/	ULONG	fr16_apiebp;		/* calling convention in the kernel */
/*c*/	ULONG	fr16_apiesp;
/*10*/	ULONG	fr16_apiebx;
/*14*/	ULONG	fr16_apiedx;
/*18*/	ULONG	fr16_apiecx;
/*1c*/	ULONG	fr16_apieax;
/*20*/	ULONG	fr16_apigs;
/*24*/	ULONG	fr16_apifs;
/*28*/	ULONG	fr16_apies;
/*2c*/	ULONG	fr16_apids;
/*30*/	ULONG	fr16_apieflags;
/*34*/	ADDR16	fr16_syscret;		/* return from h_Sec16Router, don't touch */
/*38*/	ADDR16	fr16_worker;		/* worker routine, don't touch */
/*3c*/	USHORT	fr16_bpsave;		/* saved BP */
/*3e*/	USHORT	fr16_reserved1_;	/* retaddr to_farcall, don't touch */
/*40*/	ULONG	fr16_reserved2_;	/* internal scratch */
/*44*/	USHORT	fr16_esset;		/* ES to set before entering worker */
/*46*/	USHORT	fr16_dsset;		/* DS to set before entering worker */
/*48*/	ADDR16	fr16_tmpbuf1;		/* temporary buffer for 1st ASCIZ arg */
/*4c*/	ADDR16	fr16_tmpbuf2;		/* temporary buffer for 2nd ASCIZ arg */
/*50*/	USHORT	fr16_reserved3_;	/* unused? */
/*52*/	USHORT	fr16_rpl23;		/* DPL used to pass results back */
/*54*/	ULONG	fr16_edi;		/* save regs */
/*58*/	ULONG	fr16_esi;
/*5c*/	ULONG	fr16_ebp;
/*60*/	ULONG	fr16_esp;
/*64*/	ULONG	fr16_ebx;
/*68*/	ULONG	fr16_edx;
/*6c*/	ULONG	fr16_ecx;
/*70*/	ULONG	fr16_eax;
/*74*/	ULONG	fr16_gs;
/*78*/	ULONG	fr16_fs;
/*7c*/	ULONG	fr16_es;
/*80*/	ULONG	fr16_ds;
/*84*/	USHORT	fr16_reserved4_;	/* retaddr from pre_sci, scratch */
/*86*/	USHORT	fr16_argc;
/*88*/	ADDR16	fr16_reserved5_;	/* retaddr to SCIreturn*, don't touch */
/*8c*/	ULONG	fr16_eip;		/* callgate16 return */
/*90*/	ULONG	fr16_cs;
	union {
/*94*/		USHORT	s[1];
/*94*/		ULONG	l[1];
	} fr16_argv;			/* arguments */
};
#pragma pack()

#pragma pack(1)
struct frame32 {
/*0*/	ULONG	fr32_syscret;	/* return address to syscall, don't touch */
/*4*/	ULONG	fr32_fcode;	/* function code */
/*8*/	ULONG	fr32_worker;	/* worker routine for syscall, don't touch */
/*c*/	ULONG	fr32_edi;	/* save registers */
/*10*/	ULONG	fr32_esi;
/*14*/	ULONG	fr32_ebp;
/*18*/	ULONG	fr32_esp;
/*1c*/	ULONG	fr32_ebx;
/*20*/	ULONG	fr32_edx;
/*24*/	ULONG	fr32_ecx;
/*28*/	ULONG	fr32_eax;
/*2c*/	ULONG	fr32_gs;
/*30*/	ULONG	fr32_fs;
/*34*/	ULONG	fr32_es;
/*38*/	ULONG	fr32_ds;
/*3c*/	ULONG	fr32_reserved_;	/* return addr from KMEnterKmodePASCALSEF, scratch */
/*40*/	ULONG	fr32_argc;	/* number of argument bytes in fr32_argv */
/*44*/	ULONG	fr32_eflags;
/*48*/	ULONG	fr32_eip;
/*4c*/	ULONG	fr32_cs;
	union {
/*50*/		USHORT	s[1];
/*50*/		ULONG	l[1];
	} fr32_argv;		/* arguments */
};
#pragma pack()

struct noptime {
	short yr,mon,day,wday,tz,hr,min,sec,hsec;
};

struct timedate_t {
	ULONG date;	/* 19970929 */
	ULONG time;	/* 13275834 */
};

#pragma pack(1)
struct giseg {
	ULONG	g_time;
	ULONG	g_ms;
	UCHAR	g_hour;
	UCHAR	g_min;
	UCHAR	g_sec;
	UCHAR	g_msec;
	USHORT	g_tz;
	USHORT	g_ustim;
	UCHAR	g_day;
	UCHAR	g_month;
	USHORT	g_year;
	UCHAR	g_wday;
	UCHAR	g_majvers;
	UCHAR	g_minvers;
	UCHAR	g_revision;
	UCHAR	g_sgcur;
	UCHAR	g_sgmax;
	UCHAR	g_hshift;
	UCHAR	g_pmonly;
	USHORT	g_pidfg;
	UCHAR	g_dynsched;
	UCHAR	g_maxwait;
	USHORT	g_minslice;
	USHORT	g_maxslice;
	USHORT	g_bootdrv;
	UCHAR	g_traceflgs[32];
	UCHAR	g_maxvio;
	UCHAR	g_sgPMmax;
};
#pragma pack()

#pragma pack(1)
struct liseg {
	PID	l_pidcur;
	PID	l_pidpar;
	USHORT	l_prtycur;
	TID	l_tidcur;
	USHORT	l_sgcur;
	UCHAR	l_procstat;
	UCHAR	l_reserved1_;
	USHORT	l_fg;
	UCHAR	l_proctype;
	UCHAR	l_reserved2_;
	SEL	l_selenv;
	USHORT	l_offcmdline;
	USHORT	l_dseg;
	USHORT	l_stksz;
	USHORT	l_heap;
	USHORT	l_hmod;
	SEL	l_selds;
};

#endif
